#include "CMQObject.h"

#if MQPLUGIN_VERSION >= 0x0399
#define MESSAGEBOX_(message, title) MQDialog::MessageInformationBox(MQWindow::GetMainWindow(), message, title);
#else
#define MESSAGEBOX_(message, title) MessageBox(MQ_GetWindowHandle(), cmq::tostring(message).c_str(), cmq::tostring(title).c_str(), MB_OK);
#endif

class TransMorphOther : public MQObjectPlugin
{
public:
	TransMorphOther() : doc(nullptr) {}
	virtual ~TransMorphOther() {}

	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	virtual const char *GetPlugInName(void);
	virtual const char *EnumString(int index);
	virtual BOOL Execute(int index, MQDocument doc);

	BOOL main();

private:
	cmq::CMQDocument doc;
	cmq::CMQObject objsrc; // \[XIuWFNg
	cmq::CMQObject objdst; // fIuWFNg
	std::vector<cmq::CMQObject> vecobjmorph; // IWi[t
	std::vector<cmq::CMQObject> vecobjnewmorph; // ǉ[t
	std::unordered_map<int, std::vector<std::pair<cmq::vindex_t, float>>> vecmap; // ߐڒ_Ή}bvAt

	BOOL getSelectedObjectList();
	BOOL getMorphObjects();
	std::string getObjectMainName(const std::string &origname);
	bool isMorphObject(const std::string &objname, const std::string &morphobjname);
	void TransMorphOther::createMorphlist();
	BOOL addNewMorph();
	BOOL makeVertexmap();
	BOOL transMorph();
	MQPoint TransMorphOther::IDW(int vindex, std::vector<std::pair<cmq::vindex_t, float>> &nearvertex, cmq::CMQObject &morphobj);
	BOOL callDialog();

	// _CAOݒl
	static struct TransMorphSetting {
		bool selected_vertex_only; // I𒸓_̂݃[tf
		bool morph_additional_vertex; // ǉ_Ƀ[tf
		bool backup; // GgobNAbv
		bool going; // OK or LZ
		std::string srcname;
		std::string dstname;
		std::vector<std::pair<cmq::CMQObject, bool> > morphlist; // Ip[tIuWFNgXg
	} transMorphSetting; // _CAOݒl

	static BOOL CALLBACK TransMorphOtherDialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

	friend class TransMorphOtherWindow;

};

