#include <windows.h>
#include "MQPlugin.h"
#include "MQBasePlugin.h"

#include "TransMorphOtherWindow.h"
#include "TransMorphOther.h"

TransMorphOtherWindow::TransMorphOtherWindow(MQWindowBase& parent, TransMorphOther *pPlugin) : MQDialog(parent), m_pPlugin(pPlugin)
{
	setlocale(LC_CTYPE, "");
	wchar_t buffer[256] = L"TransMorphOther";
	//	LoadStringW(hInstance, IDS_TITLE, buffer, _countof(buffer));
	SetTitle(buffer);
	SetCanResize(true);
	MQFrame *mainFrame = CreateVerticalFrame(this);
	mainFrame->SetVertLayout(LAYOUT_FILL);

	MQFrame *flameL1 = CreateHorizontalFrame(mainFrame);
	MQFrame *flameL2 = CreateHorizontalFrame(mainFrame);
	flameL2->SetVertLayout(LAYOUT_FILL);
	flameL2->SetHorzLayout(LAYOUT_FILL);

	MQFrame *flameL1B1 = CreateHorizontalFrame(flameL1);
	flameL1B1->SetHorzLayout(LAYOUT_FILL);
	flameL1B1->SetMatrixColumn(2);
	MQFrame *flameL1B2 = CreateVerticalFrame(flameL1);
	flameL1B2->SetFillRateX(30);
	MQFrame *flameL1B3 = CreateVerticalFrame(flameL1);
	flameL1B3->SetFillRateX(10);

	// source, destination
	MQLabel *label_source = CreateLabel(flameL1B1, L"Source");
	label_source->SetFillRateX(30.0);
	MQEdit *edit_source = CreateEdit(flameL1B1);
	edit_source->SetReadOnly(true);
	edit_source->SetText(cmq::towstring(m_pPlugin->transMorphSetting.srcname));
	edit_source->SetHorzLayout(LAYOUT_FILL);
	edit_source->SetFillRateX(70.0);

	MQLabel *label_destination = CreateLabel(flameL1B1, L"Destination");
	label_destination->SetFillRateX(30.0);
	MQEdit *edit_destination = CreateEdit(flameL1B1);
	edit_destination->SetReadOnly(true);
	edit_destination->SetText(cmq::towstring(m_pPlugin->transMorphSetting.dstname));
	edit_destination->SetHorzLayout(LAYOUT_FILL);
	edit_destination->SetFillRateX(70.0);

	// OK,Cancel
	MQButton *button_ok = CreateButton(flameL1B3);
	button_ok->SetText(L"OK");
	button_ok->SetDefault(true);
	button_ok->SetModalResult(DIALOG_OK);
	MQButton *button_cancel = CreateButton(flameL1B3);
	button_cancel->SetText(L"Cancel");
	button_cancel->SetCancel(true);
	button_cancel->SetModalResult(DIALOG_CANCEL);

	MQFrame *flameL2B1 = CreateVerticalFrame(flameL2);
	MQFrame *flameL2B2 = CreateVerticalFrame(flameL2);
	flameL2B1->SetHorzLayout(LAYOUT_FILL);

	// List
	MQFrame *flameL2B1L1 = CreateHorizontalFrame(flameL2B1);
	MQButton *button_all = CreateButton(flameL2B1L1);
	button_all->SetText(L"SđI(&Z)");
	button_all->AddClickEvent(this, &TransMorphOtherWindow::clickAll);
	MQButton *button_invert = CreateButton(flameL2B1L1);
	button_invert->SetText(L"I𔽓](&C)");
	button_invert->AddClickEvent(this, &TransMorphOtherWindow::clickInvert);
	list = CreateListBox(flameL2B1);
	list->SetVertLayout(LAYOUT_FILL);
	list->SetMultiSelect(true);
	listup();
	// options
	check_selvert = CreateCheckBox(flameL2B2, L"I𒸓_̂݃[tf(&S)");
	check_backup = CreateCheckBox(flameL2B2, L"obNAbvGg쐬(&X)");
	check_backup->SetChecked(true);

	AddKeyDownEvent(this, &TransMorphOtherWindow::keyevent);
}

void TransMorphOtherWindow::listup()
{
	list->ClearItems();
	for (std::pair<cmq::CMQObject, bool> &p : m_pPlugin->transMorphSetting.morphlist) {
		std::string objname = p.first.getName();
		std::wstring name = cmq::towstring(objname.c_str());
		int i = list->AddItem(name);
		list->SetItemSelected(i, p.second ? TRUE : FALSE);
	}
	list->MakeItemVisible(0);
}

BOOL TransMorphOtherWindow::clickAll(MQWidgetBase *sender, MQDocument doc)
{
	list->SetEnabled(false);
	int count = list->GetItemCount();
	for (int i = 0; i < count; i++) {
		list->SetItemSelected(i, true);
	}
	list->SetEnabled(true);
	return FALSE;
}

BOOL TransMorphOtherWindow::clickInvert(MQWidgetBase *sender, MQDocument doc)
{
	list->SetEnabled(false);
	int count = list->GetItemCount();
	for (int i = 0; i < count; i++) {
		list->SetItemSelected(i, !list->GetItemSelected(i));
	}
	list->SetEnabled(true);
	return FALSE;
}

BOOL TransMorphOtherWindow::checkSelVert(MQWidgetBase *sender, MQDocument doc) { check_selvert->SetChecked(!check_selvert->GetChecked()); return FALSE; }
BOOL TransMorphOtherWindow::checkBackup(MQWidgetBase *sender, MQDocument doc) { check_backup->SetChecked(!check_backup->GetChecked()); return FALSE; }

BOOL TransMorphOtherWindow::keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param)
{
	if (param.Alt) {
		switch (param.Key) {
		case 0x5A: clickAll(sender, doc); break;
		case 0x43: clickInvert(sender, doc); break;
		case 0x53: checkSelVert(sender, doc); break;
		case 0x58: checkBackup(sender, doc); break;
		}
	}
	return FALSE;
}
